      SUBROUTINE  fitloop(who,err)
c
c...Do The Fitting Here
c
      INCLUDE
     *         'parfit.inc'
      PARAMETER
     *         schop = 2.5D00,
     *         ngrab = 10
      INTEGER
     *         who, err, i, grabid(NGRAB)
      DOUBLE PRECISION
     *         trim
      DATA
     *    grabid/300, 563, 339, 503, 133,
     *           475, 590, 645, 652, 496/
c
 9001 FORMAT ('f', i4.4, '.b')
c
  100 CALL psplit(who,err)
      IF (err.ne.0) RETURN
c
c...Blue Fit
c
      CALL bweight(nb,pbmag,bsrc,bwgt)
      CALL pfit(nb,pbmag,sbmag,bwgt,bres,bin,
     *          nbcoef,bcoef,sbcoef,sigmab)
      IF (sigmab.lt.0.0D00) THEN
        err = -21
        RETURN
      ENDIF
      IF (dochop.ne.0) THEN
        trim = SCHOP*sigmab
        CALL ptrim(nb,bres,bin,trim)
        CALL pfit(nb,pbmag,sbmag,bwgt,bres,bin,
     *            nbcoef,bcoef,sbcoef,sigmab)
        IF (sigmab.lt.0.0D00) THEN
          err = -22
          RETURN
        ENDIF
      ENDIF
      CALL newcoef(nbcoef,bcoef)
c
c...Red Fit
c
      CALL rweight(nr,prmag,rsrc,rwgt)
      CALL pfit(nr,prmag,srmag,rwgt,rres,rin,
     *          nrcoef,rcoef,srcoef,sigmar)
      IF (sigmar.lt.0.0D00) THEN
        err = -23
        RETURN
      ENDIF
      IF (dochop.ne.0) THEN
        trim = SCHOP*sigmar
        CALL ptrim(nr,rres,rin,trim)
        CALL pfit(nr,prmag,srmag,rwgt,rres,rin,
     *            nrcoef,rcoef,srcoef,sigmar)
        IF (sigmar.lt.0.0D00) THEN
          err = -24
          RETURN
        ENDIF
      ENDIF
      CALL newcoef(nrcoef,rcoef)
c
c...Save Plate By Plate Mean Residuals
c
      CALL bresid(who)
      CALL rresid(who)
c
c...Save Things
c
      IF (NGRAB.gt.0) THEN
        DO i=1,NGRAB
          IF (who.eq.grabid(i)) THEN
            CALL parsample(who)
          ENDIF
        ENDDO
      ENDIF
      write (*,9991) who,(bcoef(i),i=1,nbcoef),
     * (rcoef(i),i=1,nrcoef)
 9991 format (i4, 2(f10.3, f10.6))
      RETURN
      END
