      SUBROUTINE  getxid
c
c...Gobble The XID File
c
      INCLUDE
     *            'usexid.inc'
      INTEGER
     *            i1, i2, i3, i4, i5, i6, i7, i, j, err, IARGC, nlb
      CHARACTER*64
     *            lb
c
 9001 FORMAT (' Star Name: ' $)
 9002 FORMAT (q, a)
 9003 FORMAT (3i6, 4i12)
 9004 FORMAT (' Cannot Open ', a, '.xid')
 9005 FORMAT (' NPi=', i4, '  Nerr=', i4)
 9006 FORMAT (' Survey Read Error=', i10)
c
c...Get And Open File
c
      j = IARGC()
  100 IF (j.gt.0) THEN
        CALL getarg(1,sname)
        nsname = 0
        DO i=1,LEN(sname)
          IF (sname(i:i).le.' ') GO TO 102
          nsname = nsname+1
        ENDDO
  102   j = 0
      ELSE
        WRITE (*,9001)
        READ  (*,9002,err=100,end=210) nsname,sname
      ENDIF
      CALL f_doenv('PIPROG:'//sname(1:nsname)//'.xid',nlb,lb)
      OPEN (
     *      access='sequential',
     *      carriagecontrol='list',
     *      dispose='keep',
     *      err=200,
     *      form='formatted',
     *      name=lb(1:nlb),
     *      readonly,
     *      shared,
     *      status='old',
     *      unit=1
     *     )
      npi = 0
c
c...Fill The Arrays
c
  110 READ (1,9003,err=110,end=120) i1,i2,i3,i4,i5,i6,i7
      npi = npi+1
      piid(npi) = i1
      IF (npi.eq.1) THEN
        src = i2
        field = i3
      ENDIF
      pibid(npi) = i4
      pirid(npi) = i5
      j = i6/1000000
      pim1(npi) = 0.1*j
      i6 = i6 - j*1000000
      j = i6/1000
      pim2(npi) = 0.1*j
      i6 = i6 - j*1000
      pim3(npi) = 0.1*i6
      pibr(npi) = i7
      GO TO 110
  120 CLOSE (1)
c
c...Fill The Big Arrays
c
      IF (src.eq.1) THEN
        CALL p1xid(field,'so',4,nb,bbuf,err)
        IF (err.ne.0) GO TO 220
        DO j=1,nb
          bbuf(j) = MOD(bbuf(j),10000)
        ENDDO
        CALL p1xid(field,'se',4,nr,rbuf,err)
        IF (err.ne.0) GO TO 220
        DO j=1,nr
          rbuf(j) = MOD(rbuf(j),10000)
        ENDDO
      ELSE
        STOP 'Unknown SRC'
      ENDIF
c
c...Sanity Check
c
      i4 = 0
      DO j=1,npi
        i1 = MOD(bbuf(pibid(j)),10000)
        i1 = (i1+5)/10
        bmag(j) = 0.1*i1
        i2 = MOD(rbuf(pirid(j)),10000)
        i2 = (i2+5)/10
        rmag(j) = 0.1*i2
        i3 = 1000*i1 + i2
        IF (i3.ne.pibr(j)) THEN
          i4 = i4+1
        ENDIF
      ENDDO
      WRITE (*,9005) npi,i4
      RETURN
c
c...Problems
c
  200 WRITE (*,9004) sname(1:nsname)
      GO TO 100
  210 CALL EXIT
  220 WRITE (*,9006) err
      CALL EXIT
      END
